package com.gct.tools.etlcamelhuge.routeconfig;

import ch.qos.logback.core.db.dialect.DBUtil;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.gct.common.util.SGTUtil;
import com.gct.tools.etlcamelhuge.MQ.MessageBody;
import com.gct.tools.etlcamelhuge.MQ.MessageProducer;
import com.gct.tools.etlcamelhuge.entity.DiagnoseMsg;
import com.gct.tools.etlcamelhuge.entity.ZDJG_WELL;
import lombok.extern.slf4j.Slf4j;
import org.apache.camel.*;
import org.apache.camel.builder.RouteBuilder;
//import org.apache.rocketmq.common.message.Message;
import org.apache.camel.model.ExpressionNode;
import org.apache.camel.model.ProcessorDefinition;
import org.apache.camel.model.RouteDefinition;
import org.apache.rocketmq.spring.core.RocketMQTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.util.StringUtils;

import javax.annotation.Resource;
import javax.sql.DataSource;
import java.io.*;
import java.math.BigDecimal;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.Period;
import java.time.format.DateTimeFormatter;
import java.util.*;

/**
 * class name: CamelJDBCConfiguration
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/4/14 下午3:16
 */
@Slf4j
@Configuration
public class CamelJDBCConfiguration /*extends RouteBuilder*/ {

    private JdbcTemplate jdbcTemplate;

    @Resource(name = "oracle_A2")
    DataSource baseDataSource;


    public Map<String, Object> getJbzq(String date, String wellId) {
        List<Map<String, Object>> list = new ArrayList<>();
        String zq = "";

        try {
            jdbcTemplate = new JdbcTemplate(baseDataSource);
            String sql = " Select jh,scjbrq,jbyy From ( Select t.jh,t.wgrq scjbrq,t.csmc jbyy, row_number() Over(Partition By t.jh   Order By t.wgrq Desc) rn   FROM Ddcc03_v t Where t.jh= '" + wellId + "' And t.wgrq<=date'" + date + "')  Where rn < 3 ";
            list = jdbcTemplate.queryForList(sql);
            if (list.size() > 0) {
                String scjbrq = list.get(0).get("SCJBRQ").toString().substring(0, 10);
                list.get(0).put("ZQ", "");
                if (list.size() > 1) {
                    String scjbrq_two = list.get(1).get("SCJBRQ").toString().substring(0, 10);
                    DateTimeFormatter fmt = DateTimeFormatter.ofPattern("yyyy-MM-dd");
                    LocalDate date3 = LocalDate.parse(scjbrq, fmt);
                    LocalDate date4 = LocalDate.parse(scjbrq_two, fmt);

                    Period p = Period.between(date4, date3);
                    if (p.getDays() > 0) {
                        zq += ((p.getYears() * 12 + p.getMonths()) * 30 + p.getDays()) + "天";
                    }
                    list.get(0).put("ZQ", zq);
                }
            } else {
                return null;
            }
        } catch (Exception e) {
            log.info("检泵周期中的{}", list.get(0).get("JH"));
        }
        return list.get(0);

    }


    public ArrayList<ZDJG_WELL> loadKey() throws java.lang.Exception {
        String url = "http://11.72.128.71/api-service/device/query?appKey=MOsEWVl8S0";
        URL restURL = new URL(url);
        /*
         * 此处的urlConnection对象实际上是根据URL的请求协议(此处是http)生成的URLConnection类 的子类HttpURLConnection
         */
        HttpURLConnection conn = (HttpURLConnection) restURL.openConnection();
        //请求方式
        conn.setRequestMethod("POST");
        //设置是否从httpUrlConnection读入，默认情况下是true; httpUrlConnection.setDoInput(true);
        conn.setDoOutput(true);
        //allowUserInteraction 如果为 true，则在允许用户交互（例如弹出一个验证对话框）的上下文中对此 URL 进行检查。
        conn.setAllowUserInteraction(false);
//        conn.setRequestProperty("Content-type", "application/json");
        conn.connect();

        DataOutputStream out = new DataOutputStream(conn
                .getOutputStream());
        String content = "type" + "=simple";
        content += "&pageSize=" + 5000;
        content += "&page=" + 1;
//        String encode = URLEncoder.encode(content, "UTF-8");
        out.writeBytes(content);

        out.flush();
        out.close();

        InputStream inputStream = conn.getInputStream();
        InputStreamReader inputStreamReader = new InputStreamReader(inputStream, "UTF-8");
        BufferedReader bReader = null;
        bReader = new BufferedReader(inputStreamReader);

        String line, resultStr = "";

        while (null != (line = bReader.readLine())) {
            resultStr += line;
        }
        bReader.close();

        JSONObject json = JSONObject.parseObject(resultStr);
        JSONArray data = json.getJSONArray("data");
        ArrayList<ZDJG_WELL> list = new ArrayList<>();
        long startTime = System.currentTimeMillis();
        ZDJG_WELL zdjg_well = null;
        for (int i = 0; i < data.size(); i++) {
//            r.delay(404);
            String id = data.getJSONObject(i).get("id").toString();
            String well_id = data.getJSONObject(i).get("code").toString();
            String param = id + "/upData/计量间计量日产液";
            String s = loadDate(param, well_id);
//            System.out.println(i);
            zdjg_well = new ZDJG_WELL();
            if (!s.equals("")) {
                zdjg_well.setJljcyl(Double.parseDouble(s));
                zdjg_well.setWell_id(well_id);
                list.add(zdjg_well);
            }

        }
        long endTime = System.currentTimeMillis();
        System.out.println(endTime - startTime);
        return list;
    }

    public String loadDate(String param, String wellId) throws java.lang.Exception {
        String date = getDate();
        Calendar ca = Calendar.getInstance();//得到一个Calendar的实例
        ca.setTime(new Date()); //设置时间为当前时间
        ca.add(Calendar.DATE, -1);
        SimpleDateFormat sf = new SimpleDateFormat("yyyy-MM-dd");
        String date1 = sf.format(ca.getTime());

        URL restURL = new URL("http://11.72.128.71/api-service/tsdb/getSeries?appKey=MOsEWVl8S0");

        //此处的urlConnection对象实际上是根据URL的请求协议(此处是http) 生成的URLConnection类 的子类HttpURLConnection
        HttpURLConnection conn = (HttpURLConnection) restURL.openConnection();

        //请求方式
        conn.setRequestMethod("POST");

        //设置是否从httpUrlConnection读入，默认情况下是true; httpUrlConnection.setDoInput(true);
        conn.setDoOutput(true);

        //allowUserInteraction 如果为 true，则在允许用户交互（例如弹出一个验证对话框）的上下文中对此 URL 进行检查。
        conn.setAllowUserInteraction(false);
        DataOutputStream out = new DataOutputStream(conn
                .getOutputStream());

        String content = "id=" + URLEncoder.encode(param, "UTF-8");
        content += "&type=number";
        content += "&startTime=" + URLEncoder.encode(date1 + "T00:00:00+0800", "UTF-8");

        content += "&endTime=" + URLEncoder.encode(date + "T00:00:00+0800", "UTF-8");
        String encode = URLEncoder.encode(content, "UTF-8");
        out.writeBytes(content);
        out.flush();
        out.close();
        PrintStream ps = new PrintStream(conn.getOutputStream());

        ps.close();

        InputStream is = null;
        if (conn.getResponseCode() == 200) {
            is = conn.getInputStream();
        } else {
            is = conn.getErrorStream();
        }
        BufferedReader bReader = new BufferedReader(new InputStreamReader(is));
        List<String> list = new ArrayList<>();

        String line, resultStr = "";
        while (null != (line = bReader.readLine())) {
            resultStr += line;
        }

        JSONObject json = null;
        String data = "";
        try {
            json = JSONObject.parseObject(resultStr);
            if (json != null) {
                JSONArray data1 = json.getJSONArray("data");
                data = data1.getJSONObject(0).getString("value");
            }
        } catch (java.lang.Exception e) {
//            System.out.println(resultStr);
        }
        bReader.close();
        is.close();
        return data;
    }

    public Double min(String[] strings) {
        double[] doubles = new double[strings.length];
        for (int i = 0; i < strings.length; i++) {
            doubles[i] = Double.parseDouble(strings[i]);
        }
        return Arrays.stream(doubles).min().getAsDouble();
    }

    //获取最大载荷
    public Double max(String[] strings) {
        double[] doubles = new double[strings.length];
        for (int i = 0; i < strings.length; i++) {
            doubles[i] = Double.parseDouble(strings[i]);
        }
        return Arrays.stream(doubles).max().getAsDouble();
    }


    public String getDate() {
        return LocalDateTime.now().format(DateTimeFormatter.ofPattern("yyyy-MM-dd"));
    }
//    public static String getDate()
//    {
//        SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");//设置日期格式
//        String date = df.format(new java.util.Date());// new Date()为获取当前系统时间
//        return date;
//    }

    @Resource(name = "diagnoseMessageProducer")
    private MessageProducer producer;

    @Bean
    public RouteBuilder routeBuilderWithOracle1() {
        return new RouteBuilder() {
            private SortedSet<String> organization;
            private Map<String, Integer> orgIDs = new HashMap<>();
            private int orgID;
            private Map<Object, Object> orgIdPreList;
            private Integer org;

            public ProcessorDefinition<ExpressionNode> setMyBody(RouteDefinition route) {
                return route.setBody(simple("select well_id from centralbase.sys_access_well_control  where  access_status='1'  "))
                        .to("jdbc:centralbase")
                        .split(body()).process(exchange -> {
                            HashMap body = exchange.getIn().getBody(HashMap.class);
                            exchange.getIn().setHeader("well_id", body.get("well_id"));
                        });
            }

            //全部执行完成的大概时间在30-40分钟
            @Override
            public void configure() throws Exception {
               /* RouteDefinition OrgAndWellSource= (RouteDefinition) from("timer:insert-OrgAndWellSource?period=86400000")
                        .routeId("insert-OrgAndWellSource")
                        .setHeader("date", constant(getDate()))
                        .process(exchange -> {
                            org = 0;
                            orgIdPreList = new HashMap<>();
                        })
                        .setBody(simple("select  max(cast(org_id as int))  from centralbase.cb_pc_organization"))
                        .to("jdbc:centralbase")
                        .process(exchange -> {
                            HashMap body = exchange.getIn().getBody(HashMap.class);
                            if (body == null || StringUtils.isEmpty(body.get("max"))) org = 0;
                            else
                                org = Integer.valueOf(body.get("max").toString());
                        })
                        .setBody(simple("select org_id_pre,org_id from centralbase.cb_pc_organization"))
                        .to("jdbc:centralbase")
                        .split(body()).process(exchange -> {
                            HashMap body = exchange.getIn().getBody(HashMap.class);
                            orgIdPreList.put(body.get("org_id_pre"),body.get("org_id"));
                            orgIDs.put(body.get("org_id_pre").toString(),Integer.valueOf(body.get("org_id").toString()));
                        }).end();
                setMyBody(OrgAndWellSource)

                        .setBody(simple("select distinct a.well_common_name jh, a.org_name_cj zyq, a.GROUP_UNIT_NAME cw, a.station_name zd, a.project_name qk from V_CD_WELL_SOURCE_YC a where a.well_common_name ='${header.well_id}' "))
//                        .setBody(simple("select  distinct jh,cydmc,zyq,zk,qyrq,sccw,qk,bz from DBA01 where jh ='${header.well_id}' "))
                        .to("jdbc:oracle_A2")
                        .transform()
                        .body((result) -> {
                            organization = new TreeSet<>();
                            return result;
                        })
                        .step("1")
                        .split(body()).process(exchange -> {
                    Message in = exchange.getIn();
                    HashMap<String, Object> aRow = in.getBody(HashMap.class);
                    String org_level3 = aRow.get("ZYQ") + "@" + aRow.get("QK") + "@" + aRow.get("ZD");
                    String org_level2 = aRow.get("ZYQ") + "@" + aRow.get("QK");
                    String org_level1 = aRow.get("ZYQ").toString();
                    aRow.put("station_id", org_level3);
                    orgID = org;
                    if ((!orgIdPreList.containsKey(org_level1)) || (!orgIdPreList.containsKey(org_level2)) || (!orgIdPreList.containsKey(org_level3))) {
                        if (organization.add(org_level1)) {
                            if (!orgIDs.containsKey(org_level1)) orgIDs.put(org_level1,++orgID);
                        }
                        if (organization.add(org_level2)) {
                            if (!orgIDs.containsKey(org_level2)) orgIDs.put(org_level2,++orgID);
                        }
                        if (organization.add(org_level3)) {
                            if (!orgIDs.containsKey(org_level3)) orgIDs.put(org_level3,++orgID);
                        }
                    }
                    if(orgIdPreList.get(org_level3) !=null){
                        aRow.put("org_id",orgIdPreList.get(org_level3));
                        return;
                    }
                    if(orgIDs.get(org_level3) !=null){
                        aRow.put("org_id",orgIDs.get(org_level3));
                    }
                })                                                                             //                                         完井层位ID 井站名称|站库名称 生产层段名称    生产区块名称
                        .setBody(simple("insert into centralbase.cb_cd_well_source (well_id,well_common_name,org_id,station_id,station_name,completion_name,PRODUCING_AREA_name) " +
                                "select '${body[JH]}','${body[JH]}','${body[org_id]}','${body[station_id]}','${body[ZD]}','${body[CW]}','${body[QK]}' " +
                                "where NOT EXISTS ( SELECT * FROM centralbase.cb_cd_well_source WHERE well_id = '${body[JH]}' )"))
                        .to("jdbc:centralbase")
                        .end()
                        .transform().body((re) -> {
                    List<Map<String, Object>> rows = new ArrayList<>();
                    for (String s : organization) {
                        Map<String, Object> row = new HashMap<>();
                        String[] orgs = s.split("@");
                        row.put("org_id_pre", s);
                        switch (orgs.length) {
                            case 1:
                                row.put("org_name", orgs[0]);
                                row.put("org_level", 1);
                                row.put("org_parent", "0");
                                break;
                            case 2:
                                row.put("org_name", orgs[1]);
                                row.put("org_level", 2);
                                row.put("org_parent", orgIDs.get(orgs[0]).toString());
                                break;
                            case 3:
                                row.put("org_name", orgs[2]);
                                row.put("org_level", 3);
                                row.put("org_parent", orgIDs.get(orgs[0] + "@" + orgs[1]).toString());
                                break;
                        }
                        if (!orgIdPreList.containsKey(s)) {
                            org++;
                            row.put("org_code", org);
                            row.put("org_id", "" + org);
                            orgIdPreList.put(s, row.get("org_id"));
                            rows.add(row);
                        }
                    }
                    return rows;
                }).split(body())
                        .setBody(simple("insert into centralbase.cb_pc_organization(org_id,org_code,org_name,org_level,parent_id,org_id_pre)" +
                                "select '${body[org_id]}','${body[org_code]}','${body[org_name]}','${body[org_level]}','${body[org_parent]}','${body[org_id_pre]}' " +
                                "where NOT EXISTS ( SELECT * FROM centralbase.cb_pc_organization WHERE org_id = '${body[org_id]}')"))
                        .doTry()
                        .to("jdbc:centralbase")
                        .doCatch(Exception.class)
                        .log("${header.date}"+" routeId:insert-OrgAndWellSource->  centralbase.cb_pc_organization insert data failed")
                        .end();



                from("timer:update-wellControl?period=3600000")
                        .routeId("update-wellControl")
                        .setBody(simple("select scc.well_id,wo.well_common_name,op.org_id from centralbase.sys_access_well_control scc\n" +
                                "left join centralbase.cb_cd_well_source wo on scc.well_id = wo.well_id\n" +
                                "left join centralbase.cb_pc_organization op on wo.org_id = op.org_id\n" +
                                "where scc.access_status ='1' "))
                        .to("jdbc:centralbase")
                        .split(body())
                        .split(body()).process(exchange -> {
                    HashMap<String, Object> body = exchange.getIn().getBody(HashMap.class);
                    String format = LocalDateTime.now().format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
                    if (body.get("well_common_name") == null || body.get("well_common_name").equals("")) {
                        body.put("remarks","暂无井信息");
                        body.put("error_id",0);
                        body.put("updateTime",format);
                    }else if (body.get("org_id") == null || body.get("org_id").equals("")){
                        body.put("remarks","暂无机构信息");
                        body.put("error_id",0);
                        body.put("updateTime",format);
                    }else {
                        body.put("remarks","");
                        body.put("error_id",1);
                        body.put("updateTime",format);
                    }
                })
                        .setBody(simple("update centralbase.sys_access_well_control set well_common_name='${body[well_common_name]}',org_id='${body[org_id]}',update_time = '${body[updateTime]}'::timestamp, remarks ='${body[remarks]}' ,error_id ='${body[error_id]}' where well_id ='${body[well_id]}' "))
                        .to("jdbc:centralbase")
                        .end();


                from("timer:selectAllWellName?period=3600000")
                        .routeId("selectAllWellName")
                        .setBody(simple("SELECT DISTINCT\n" +
                                "\tr.well_id WELLID \n" +
                                "FROM\n" +
                                "\tcentralbase.cb_temp_well_mech_runtime r\n" +
                                "\tLEFT JOIN centralbase.sys_access_well_control s ON r.well_id = s.well_id\n" +
                                "WHERE\n" +
                                "\tr.prod_date > '2021-10-01' \n" +
                                "\tAND stroke_length > 0\n" +
                                "\tand s.well_id is null"))
                        .to("jdbc:centralbase")
                        .split(body()).process(exchange -> {
                            Message in = exchange.getIn();
                            HashMap<String, Object> aRow = in.getBody(HashMap.class);
                            in.setHeader("date", getDate()+ " 00:00:00");
                            in.setHeader("jh",aRow.get("wellid"));
                })
                        .log("${header.jh}")
                        .doTry()
                        .setBody(simple("insert into centralbase.sys_access_well_control(well_id,well_common_name,access_status,access_status_msg,access_date,error_id)" +
                                " select '${header.jh}','${header.jh}','1','已接入','${header.date}','1' " +
                                " where NOT EXISTS ( SELECT * FROM centralbase.sys_access_well_control WHERE well_id = '${header.jh}')"))
                        .to("jdbc:centralbase")
                       .doCatch(Exception.class)
                        .log("${header.date}"+" routeId:selectAllWellName->  centralbase.sys_access_well_control update date faild")
                        .end();



                //   A2数据
                from("timer:mytimer2?period=3600000")
                        .routeId("oracle-2")
                        .setBody(simple("select max(prod_date) from centralbase.cb_temp_well_mech_runtime "))
                        .to("jdbc:centralbase")
                        .split(body()).process(exchange -> {
                            Message in = exchange.getIn();
                            in.setHeader("date", getDate());
                })
                        .setBody(simple("SELECT well_id wellid FROM centralbase.sys_access_well_control where access_status = '1' and error_id = '1' "))
                        .to("jdbc:centralbase")
                        .split(body())
//                        .setBody(simple("select v.WELL_COMMON_NAME jh,v.PROD_DATE rq,v.OIL_PRODUCTION_METHOD cyfs,v.PUMP_DIAMETER yz,v.BACK_PRES hysx,v.MAX_TUBING_PRES yysx,v.MAX_CASING_PRES tysx,v.PUMP_DEPTH bs from V_PC_PRO_COM_DAILY_CYYC_A2 v  where  v.PROD_DATE = to_date('${header.date}','yyyy-MM-dd')  and  v.WELL_COMMON_NAME = '${body[wellid]}' "))
                       .setBody(simple("select v.WELL_COMMON_NAME jh,v.PROD_DATE rq,v.OIL_PRODUCTION_METHOD cyfs,v.PUMP_DIAMETER yz,v.BACK_PRES hysx,v.MAX_TUBING_PRES yysx,v.MAX_CASING_PRES tysx,v.PUMP_DEPTH bs from V_PC_PRO_COM_DAILY_CYYC v  where  v.PROD_DATE = to_date('${header.date}','yyyy-MM-dd')  and  v.WELL_COMMON_NAME = '${body[wellid]}' "))
                        .to("jdbc:oracle_A2")
                        .split(body()).process(exchange -> {
                    Message in = exchange.getIn();
                    HashMap<String, Object> aRow = in.getBody(HashMap.class);
                    if (aRow.get("YZ") == null) aRow.put("YZ", "0.0");
                    if (aRow.get("HYSX") == null) aRow.put("HYSX", "0.0");
                    if (aRow.get("YYSX") == null) aRow.put("YYSX", "0.0");
                    if (aRow.get("TYSX") == null) aRow.put("TYSX", "0.0");
                    if (aRow.get("BS") == null) aRow.put("BS", "0.0");
                    if (aRow.get("DYM") == null)aRow.put("DYM","0.0");
                })
                        .log("${header.date}")
                        .log("mytimer2")

                        .setBody(simple("insert into centralbase.cb_pc_pro_wellbore_status_daily(well_id,prod_date,oil_prod_method,oil_nozzle,back_pres,tubing_pres,casing_pres,pump_depth,start_pump_liq_level) " +
                                "select '${body[JH]}','${body[RQ]}','${body[CYFS]}','${body[YZ]}','${body[HYSX]}','${body[YYSX]}','${body[TYSX]}','${body[BS]}' ,'${body[DYM]}'" +
                                "where NOT EXISTS ( SELECT * FROM centralbase.cb_pc_pro_wellbore_status_daily WHERE well_id = '${body[JH]}' and  prod_date = '${body[RQ]}')"))
                        .doTry()
                        .to("jdbc:centralbase")
                        .doCatch(Exception.class)
                        .log("${header.date}"+" routeId:oracle-2->  centralbase.cb_pc_pro_wellbore_status_daily insert date faild")
                        .end();


                from("timer:mytimer3?period=3600000")
                        .routeId("oracle-3")
                        .setBody(simple("select max(prod_date) from centralbase.cb_temp_well_mech_runtime "))
                        .to("jdbc:centralbase")
                        .split(body()).process(exchange -> {
                            Message in = exchange.getIn();
                            in.setHeader("date", getDate());
                })
                        .log("mytimer3b")
                        .setBody(simple("SELECT well_id wellid FROM centralbase.sys_access_well_control where access_status = '1' and error_id = '1' "))
                        .to("jdbc:centralbase")
                        .split(body())
//                        .setBody(simple("select  WELL_COMMON_NAME jh, PROD_DATE rq,PROD_TIME scsj, LIQ_PROD_DAILY rcyl1,OIL_PROD_DAILY rcyl,GAS_PROD_DAILY rcql,WATER_CUT hs,REMARKS bz from V_PC_PRO_COM_DAILY_CYYC_A2 where prod_date = to_date('${header.date}','yyyy-MM-dd') and WELL_COMMON_NAME = '${body[wellid]}'"))
//                        .setBody(simple("select  WELL_COMMON_NAME jh, PROD_DATE rq,PROD_TIME scsj, LIQ_PROD_DAILY rcyl1,OIL_PROD_DAILY rcyl,GAS_PROD_DAILY rcql,WATER_CUT hs,REMARKS bz from V_PC_PRO_COM_DAILY_CYYC where prod_date = to_date('${header.date}','yyyy-MM-dd') and WELL_COMMON_NAME = '${body[wellid]}' and LIQ_PROD_DAILY >0 "))
                        .setBody(simple("select  WELL_COMMON_NAME jh,\n" +
                                "                       PROD_DATE rq,\n" +
                                "                       PROD_TIME scsj,\n" +
                                "                       (select  sum(LIQ_PROD_DAILY) from V_PC_PRO_COM_DAILY_CYYC where prod_date = to_date('${header.date}','yyyy-MM-dd') and WELL_COMMON_NAME = '${body[wellid]}') rcyl1,\n" +
                                "                       OIL_PROD_DAILY rcyl,GAS_PROD_DAILY rcql,WATER_CUT hs,REMARKS bz\n" +
                            "                       from   V_PC_PRO_COM_DAILY_CYYC\n" +
                            "                       where prod_date = to_date('${header.date}','yyyy-MM-dd')\n" +
                            "                       and WELL_COMMON_NAME = '${body[wellid]}'  "))
                        .to("jdbc:oracle_A2")
                        .split(body()).process(exchange -> {
                    Message in = exchange.getIn();
                    HashMap<String, Object> aRow = in.getBody(HashMap.class);
                    if (aRow.get("SCSJ") == null) aRow.put("SCSJ", "0.0");
                    if (aRow.get("RCYL1") == null) aRow.put("RCYL1", "0.0");
                    if (aRow.get("RCYL") == null) aRow.put("RCYL", "0.0");
                    if (aRow.get("RCQL") == null) aRow.put("RCQL", "0.0");
                    if (aRow.get("HS") == null) aRow.put("HS", "0.0");
                    if (aRow.get("BZ") == null) aRow.put("BZ", "");
                    aRow.put("RCSL",-1);
                    aRow.put("QYB",-1);
                    aRow.put("SQB",-1);
                    if (aRow.get("RCQL")!=null && aRow.get("RCYL")!=null && !aRow.get("RCYL").equals("0.0") && aRow.get("RCYL") != "0.0"){
                        double qyb = Double.valueOf(aRow.get("RCQL").toString()) / Double.valueOf(aRow.get("RCYL").toString());
                        if (!Double.isNaN(qyb) && !Double.isInfinite(qyb)){
                            BigDecimal bd=new BigDecimal(qyb);
                            double d1=bd.setScale(1,BigDecimal.ROUND_HALF_UP).doubleValue();
                            aRow.put("QYB",d1);
                        }
                    }
                    if (aRow.get("RCYL1")!=null && aRow.get("HS") != null && !aRow.get("HS").equals("0.0") && aRow.get("HS") != "0.0"){
                        double rcsl = (Double.valueOf(aRow.get("RCYL1").toString()) * Double.valueOf(aRow.get("HS").toString()))/100;
                        if (!Double.isNaN(rcsl) && !Double.isInfinite(rcsl)) {
                            BigDecimal bd = new BigDecimal(rcsl);
                            double d1 = bd.setScale(1, BigDecimal.ROUND_HALF_UP).doubleValue();
                            aRow.put("RCSL", d1);
                        }
                    }
                    if (aRow.get("RCQL") != null && aRow.get("RCSL") != null && !aRow.get("RCQL").equals("0.0") && aRow.get("RCQL") != "0.0" ){
                        double sqb = Double.valueOf(aRow.get("RCSL").toString()) / Double.valueOf(aRow.get("RCQL").toString());
                        if (!Double.isNaN(sqb) && !Double.isInfinite(sqb)) {
                            BigDecimal bd = new BigDecimal(sqb);
                            double d1 = bd.setScale(1, BigDecimal.ROUND_HALF_UP).doubleValue();
                            aRow.put("SQB", d1);
                        }
                    }
                    if (!aRow.containsKey("SMD")){
                        aRow.put("SMD",1);
                    }
                    if (!aRow.containsKey("YMD")){
                        aRow.put("YMD",0.85);
                    }
                })
                        .log("mytimer3")
                        .setBody(simple("insert into centralbase.cb_pc_pro_wellbore_vol_daily(well_id,prod_date,prod_time,liq_prod_daily,oil_prod_daily,gas_prod_daily,water_cut,remarks,gas_oil_ratio,water_prod_daily,water_gas_ratio,surface_crude_water_density,surface_crude_oil_density) " +
                                "select '${body[JH]}','${body[RQ]}','${body[SCSJ]}','${body[RCYL1]}','${body[RCYL]}','${body[RCQL]}','${body[HS]}','${body[BZ]}','${body[QYB]}','${body[RCSL]}','${body[SQB]}','${body[SMD]}','${body[YMD]}' " +
                                "where NOT EXISTS ( SELECT * FROM centralbase.cb_pc_pro_wellbore_vol_daily WHERE well_id = '${body[JH]}' and  prod_date = '${body[RQ]}' )"))
                        .doTry()
                        .to("jdbc:centralbase")
                        .doCatch(Exception.class)
                        .log("${header.date}"+" routeId:oracle-3->  centralbase.cb_pc_pro_wellbore_status_daily insert date faild")
                        .endDoTry()
                        .setBody(simple("update centralbase.cb_pc_pro_wellbore_vol_daily set  water_prod_daily =null where water_prod_daily = -1 and prod_date = '${header.date}' "))
                        .to("jdbc:centralbase")
                        .setBody(simple("update centralbase.cb_pc_pro_wellbore_vol_daily set  gas_oil_ratio =null where gas_oil_ratio = -1 and prod_date = '${header.date}' "))
                        .to("jdbc:centralbase")
                        .setBody(simple("update centralbase.cb_pc_pro_wellbore_vol_daily set  water_gas_ratio =null where water_gas_ratio = -1 and prod_date = '${header.date}' "))
                        .to("jdbc:centralbase")
                        .doCatch(Exception.class)
                        .log("${header.date}"+" routeId:oracle-3->  centralbase.cb_pc_pro_wellbore_vol_daily update date faild")
                        .end();

                from("timer:mytimer4?period=3600000")
                    .routeId("oracle-4")
                    .setBody(simple("select max(prod_date) from centralbase.cb_temp_well_mech_runtime "))
                    .to("jdbc:centralbase")
                    .split(body()).process(exchange -> {
                        Message in = exchange.getIn();
                        in.setHeader("date", getDate());
            })
                    .setBody(simple("SELECT well_id jh FROM centralbase.sys_access_well_control where access_status = '1' and error_id = '1'"))
                    .to("jdbc:centralbase")
                    .split(body()).process(exchange -> {
                        Message in = exchange.getIn();
                        HashMap<String, Object> aRow = in.getBody(HashMap.class);
                        aRow.put("JH", aRow.get("jh").toString());
                        in.setHeader("JH",aRow.get("jh").toString());
                })
//                    .setBody(simple("Select t.jh, t.prod_date rq,t.static_pressure jy,t.flow_pres ly,t.pump_diameter bj, t.pump_depth bs,t.pump_efficiency bx,t.rotate_frequency zs,
// t.stroke_length cc,t.stroke_frequency cs, t.pump_type blx,t.elec_frequency dl,t.dynamic_liq_level dym   FROM V_TEMP_WELL_MECH_ALL t where jh = '${body[JH]}'"))
                    .setBody(simple("select  * from ( Select  v.WELL_COMMON_NAME jh, t.prod_date rq,t.static_pressure jy,t.flow_pres ly,t.pump_diameter bj, t.pump_depth bs,t.pump_efficiency bx, t.rotate_frequency zs,t.stroke_length cc,t.stroke_frequency cs, t.pump_type blx,t.elec_frequency dl, t.dynamic_liq_level dym  " +
                            " FROM V_TEMP_WELL_MECH_ALL t inner join V_CD_WELL_SOURCE_YC v on  t.well_id = v.well_id  and  v.WELL_COMMON_NAME = '${body[JH]}' and t.dynamic_liq_level > 0 " +
                            " order by rq desc) where rownum = 1"))
                    .to("jdbc:oracle_A2")
                    .split(body()).process(exchange -> {
                        Message in = exchange.getIn();
                        HashMap<String, Object> aRow = in.getBody(HashMap.class);
                        if (aRow.get("JY") == null) aRow.put("JY", "0.0");
                        if (aRow.get("LY") == null) aRow.put("LY", "0.0");
                        if (aRow.get("BJ") == null) aRow.put("BJ", "0.0");
                        if (aRow.get("BS") == null) aRow.put("BS", "0.0");
                        if (aRow.get("BX") == null) aRow.put("BX", "0.0");
                        if (aRow.get("ZS") == null) aRow.put("ZS", "0.0");
                        if (aRow.get("CC") == null) aRow.put("CC", "0.0");
                        if (aRow.get("CS") == null) aRow.put("CS", "0.0");
                        if (aRow.get("BLX") == null) aRow.put("BLX", "");
                        if (aRow.get("DL") == null) aRow.put("DL", "0.0");
                        if (aRow.get("DYM") == null) aRow.put("DYM", "0.0");
                })
                        .log("mytimer4")

                        .doTry()
                        .setBody(simple("insert into centralbase.cb_temp_well_mech_daily(well_id,prod_date,static_pressure,flow_pres,pump_diameter,pump_depth,pump_efficiency,rotate_frequency,stroke_length,stroke_frequency,pump_type,elec_frequency,elec_pump_current_b) " +
                                "select '${body[JH]}','${header.date}','${body[JY]}','${body[LY]}','${body[BJ]}','${body[BS]}','${body[BX]}','${body[ZS]}','${body[CC]}','${body[CS]}','${body[BLX]}','${body[DL]}','${body[DYM]}' " +
                                "where NOT EXISTS ( SELECT * FROM centralbase.cb_temp_well_mech_daily WHERE well_id = '${body[JH]}' and  prod_date = '${header.date}' )"))
                        .to("jdbc:centralbase")
                        .doCatch(Exception.class)
                        .log("${header.date}"+" routeId:oracle-4->  centralbase.cb_temp_well_mech_daily insert date faild")
                        .end();

                from("timer:mytimer5?period=3600000")
                        .routeId("oracle-5")
                        .setBody(simple("select max(prod_date) from centralbase.cb_temp_well_mech_runtime "))
                        .to("jdbc:centralbase")
                        .split(body()).process(exchange -> {
                            Message in = exchange.getIn();
                            in.setHeader("date", getDate()+ " 00:00:00");
                })
                        .setBody(simple("select well_id,prod_date,elec_pump_current_b from centralbase.cb_temp_well_mech_daily where prod_date = '${header.date}' "))
                        .to("jdbc:centralbase")
                        .split(body())
                        .doTry()
                        .setBody(simple("update centralbase.cb_pc_pro_wellbore_status_daily set start_pump_liq_level = '${body[elec_pump_current_b]}' where well_id = '${body[well_id]}' and prod_date  = '${body[prod_date]}'"))
                        .to("jdbc:centralbase")
                        .doCatch(Exception.class)
                        .log("${header.date}"+" routeId:oracle-5->  centralbase.cb_pc_pro_wellbore_status_daily update date faild")
                        .end();





                //计量间产液量
                from("timer:mytimer6?period=3600000")
                        .routeId("oracle-6")
                        .setBody(simple("select max(prod_date) from centralbase.cb_temp_well_mech_runtime "))
                        .to("jdbc:centralbase")
                        .split(body()).process(exchange -> {
                            Message in = exchange.getIn();
                            in.setHeader("date", getDate()+ " 00:00:00");
                            in.setHeader("data",loadKey());
                })
                        .setBody(simple("${in.header.data}"))
                        .split(body()).process(exchange -> {
                            Message in = exchange.getIn();
                            ZDJG_WELL body = in.getBody(ZDJG_WELL.class);
                            in.setHeader("jljcyl",body.getJljcyl());
                            in.setHeader("wellname",body.getWell_id());

                })
                        .doTry()
                        .setBody(simple("insert into centralbase.cb_pc_pro_well_meter_team(well_id,start_prod_date,test_liqu_vol_daily) " +
                                " select '${in.header.wellname}','${in.header.date}','${in.header.jljcyl}'" +
                                " where NOT EXISTS(select * from centralbase.cb_pc_pro_well_meter_team  where well_id = '${in.header.wellname}' and start_prod_date = '${in.header.date}') "))
                        .to("jdbc:centralbase")
                        .doCatch(Exception.class)
                        .log("${header.date}"+" routeId:oracle-6->  aoid.aoid_singlegt_yield update date faild")
                        .end();

                from("timer:mytimer7?period=3600000")
                        .routeId("oracle-7")
                        .setBody(simple("select max(prod_date) from centralbase.cb_temp_well_mech_runtime "))
                        .to("jdbc:centralbase")
                        .split(body()).process(exchange -> {
                    Message in = exchange.getIn();
                    in.setHeader("date", getDate()+ " 00:00:00");
                })
                        .setBody(simple("select well_id,prod_date,start_pump_liq_level,pump_depth from centralbase.cb_pc_pro_wellbore_status_daily where prod_date = '${header.date}' "))
                        .to("jdbc:centralbase")
                        .split(body()).process(exchange -> {
                            Message in = exchange.getIn();
                            HashMap<String, Object> aRow = in.getBody(HashMap.class);
                            aRow.put("submergence_depth",null);
                    if (aRow.get("start_pump_liq_level")!=null && aRow.get("pump_depth")!=null){
                        double cmd= Double.valueOf(aRow.get("pump_depth").toString())-Double.valueOf(aRow.get("start_pump_liq_level").toString());
                        BigDecimal bd=new BigDecimal(cmd);
                        double cmd1=bd.setScale(1,BigDecimal.ROUND_HALF_UP).doubleValue();
                        aRow.put("submergence_depth",cmd1);
                    }
                })
                        .doTry()
                        .setBody(simple("update centralbase.cb_pc_pro_wellbore_status_daily set submergence_depth = '${body[submergence_depth]}' where well_id = '${body[well_id]}' and prod_date  = '${body[prod_date]}'"))
                        .to("jdbc:centralbase")
                        .doCatch(Exception.class)
                        .log("${header.date}"+" routeId:oracle-7->  centralbase.cb_pc_pro_wellbore_status_daily update date faild")
                        .end();

                //检泵周期信息
                from("timer:mytimer8?period=3600000")
                        .routeId("oracle-8")
                        .setBody(simple("select max(prod_date) from centralbase.cb_temp_well_mech_runtime "))
                        .to("jdbc:centralbase")
                        .split(body()).process(exchange -> {
                             Message in = exchange.getIn();
                             in.setHeader("date", getDate());
                })
                        .setBody(simple("SELECT well_id wellid FROM centralbase.sys_access_well_control where access_status = '1' and error_id = '1' "))
                        .to("jdbc:centralbase")
                        .split(body()).process(exchange -> {
                    Message in = exchange.getIn();
                    HashMap<String, Object> aRow = in.getBody(HashMap.class);
//                    aRow.put("JH", aRow.get("wellid").toString());
                    Map<String, Object> map = getJbzq(getDate(), aRow.get("wellid").toString());
                    if (map !=null ){
                        aRow.put("JH",map.get("JH"));
                        aRow.put("SCJBRQ",map.get("SCJBRQ"));
                        aRow.put("JBYY", map.get("JBYY"));
                        aRow.put("ZQ",!map.get("ZQ").equals("") && map.get("ZQ") !=null ? map.get("ZQ") :"只检泵一次");

                    }
                    })
                        .doTry()
                        .setBody(simple("insert into centralbase.cb_cd_checkpump_source(well_common_name,check_pump_date,reason,period,sys_date) " +
                                        "select '${body[JH]}','${body[SCJBRQ]}','${body[JBYY]}','${body[ZQ]}','${header.date}' " +
                                        "where NOT EXISTS(select * from centralbase.cb_cd_checkpump_source where well_common_name = '${body[JH]}' and sys_date = '${header.date}')"))
                        .to("jdbc:centralbase")
                        .doCatch(Exception.class)
                        .log("${header.date}"+" routeId:oracle-8->  centralbase.cb_pc_pro_wellbore_status_daily update date faild")
                        .end();

                from("timer:mytimer10?period=3600000")
                        .routeId("centralbase-3")
                        .setBody(simple("select max(prod_date) from centralbase.cb_temp_well_mech_runtime "))
                        .to("jdbc:centralbase")
                        .split(body()).process(exchange -> {
                            Message in = exchange.getIn();
                            in.setHeader("date", getDate());
                })
                        .setBody(simple("select well_id,avg(stroke_length) stroke_length  ,avg(stroke_frequency) stroke_frequency from centralbase.cb_temp_well_mech_runtime where prod_date::date='${header.date}' group by well_id"))
                        .to("jdbc:centralbase")//.log("${body}")
                        .split(body()).process(exchange -> {
                            Message in = exchange.getIn();
                            HashMap<String, Object> aRow = in.getBody(HashMap.class);
                            if (aRow.get("stroke_length")!=null && aRow.get("stroke_frequency")!=null){
                            double stroke_length=Double.parseDouble(aRow.get("stroke_length").toString());
                            double stroke_frequency=Double.parseDouble(aRow.get("stroke_frequency").toString());
                            BigDecimal bd=new BigDecimal(stroke_length);
                            double stroke_lengt1=bd.setScale(1,BigDecimal.ROUND_HALF_UP).doubleValue();
                            BigDecimal bd1=new BigDecimal(stroke_frequency);
                            double stroke_frequency1=bd1.setScale(1,BigDecimal.ROUND_HALF_UP).doubleValue();
                            aRow.put("strokeLength",stroke_lengt1);
                            aRow.put("strokeFrequency",stroke_frequency1);
                    }
                })
                        .doTry()
                        .setBody(simple("update centralbase.cb_temp_well_mech_daily set stroke_length='${body[strokeLength]}' ,stroke_frequency ='${body[strokeFrequency]}' where well_id = '${body[well_id]}' and prod_date::date='${header.date}' "))
                        .to("jdbc:centralbase")
                        .doCatch(Exception.class)
                        .log("${header.date}"+" routeId:centralbase-3->  centralbase.cb_temp_well_mech_daily update date faild")
                        .end();

                from("timer:mytimer11?period=3600000")
                        .routeId("centralbase-1")
                        .setBody(simple("select so.well_id,so.well_common_name,so.org_id,ti.prod_date,ti.stroke_frequency,ti.stroke_length,ti.sgt from centralbase.cb_temp_well_mech_runtime ti, centralbase.cb_cd_well_source so where ti.well_id = so.well_id and ti.prod_date =(select  prod_date  from centralbase.cb_temp_well_mech_runtime GROUP BY prod_date  ORDER BY prod_date desc LIMIT  1 OFFSET 1) and ti.stroke_length > 0 and ti.sgt != '' "))
                        .to("jdbc:centralbase")
                        .split(body())
                        .doTry()
                        .process(exchange -> {
                            Message in = exchange.getIn();
                            HashMap<String, Object> aRow = in.getBody(HashMap.class);
                            String wellName =aRow.get("well_common_name").toString();
                            String wellId =aRow.get("well_id").toString();
                            String orgId = aRow.get("org_id").toString();
                            String prodDate = aRow.get("prod_date").toString().substring(0,19);
                            Double strokeLength = Double.valueOf(aRow.get("stroke_length").toString());
                            Double strokeFrequency = Double.valueOf(aRow.get("stroke_frequency").toString());
                            String sgt = aRow.get("sgt").toString();
                            DiagnoseMsg diagnoseMsg = new DiagnoseMsg(wellId, wellName, orgId, prodDate, sgt, LocalDateTime.now().toString(), strokeLength, strokeFrequency);
                            producer.send((MessageBody) diagnoseMsg);
                        })
                        .doCatch(Exception.class)
                        .log("${header.date}"+" rocketMQ send data faild")
                        .end();*/


               /* from("timer:mytimer12?period=604800000")
                        .routeId("cb_sucker_rod_specification")
                        .setBody(simple("delete from centralbase.cb_sucker_rod_specification "))
                        .to("jdbc:centralbase")
                        .setBody(simple("SELECT well_id jh FROM centralbase.sys_access_well_control where access_status = '1' and error_id = '1'"))
                        .to("jdbc:centralbase")
                        .split(body()).process(exchange -> {
                            Message in = exchange.getIn();
                            HashMap<String, Object> aRow = in.getBody(HashMap.class);
                            aRow.put("JH", aRow.get("jh").toString());
                            in.setHeader("JH", aRow.get("jh").toString());
                        })
                        .setBody(simple("select jh,csmc,cs_id csid,sgrq,wgrq,gggg,ggcd,ggsd,cygjb,yjcyggg,yjcyggs,yjcygcd," +
                                "ejcyggg,ejcyggs,ejcygcd,sjcyggg,sjcyggs,sjcygcd,sjcyggg4,sjcyggs4,sjcygcd4,cygdjcd,bz,sgjk from v_ys_daa02 where jh = '${body[JH]}' " +
                                " and  wgrq = (select max(wgrq) from v_ys_daa02 where jh = '${body[JH]}')"))
                        .to("jdbc:oracle_A2")
                        .split(body())
                        .process(exchange -> {
                            Message in = exchange.getIn();
                            Map<String, Object> aRow = in.getBody(HashMap.class);

                            if (aRow.get("GGCD") == null) aRow.put("GGCD", "0.0");
                            if (aRow.get("GGGG") == null) aRow.put("GGGG", "0.0");
                            if (aRow.get("GGSD") == null) aRow.put("GGSD", "0.0");
                            if (aRow.get("YJCYGGS") == null) aRow.put("YJCYGGS", "0.0");
                            if (aRow.get("YJCYGCD") == null) aRow.put("YJCYGCD", "0.0");
                            if (aRow.get("EJCYGGS") == null) aRow.put("EJCYGGS", "0.0");
                            if (aRow.get("EJCYGCD") == null) aRow.put("EJCYGCD", "0.0");
                            if (aRow.get("SJCYGGS") == null) aRow.put("SJCYGGS", "0.0");
                            if (aRow.get("SJCYGCD") == null) aRow.put("SJCYGCD", "0.0");
                            if (aRow.get("SJCYGGS4") == null) aRow.put("SJCYGGS4", "0.0");
                            if (aRow.get("SJCYGCD4") == null) aRow.put("SJCYGCD4", "0.0");
                            if (aRow.get("CYGDJCD") == null) aRow.put("CYGDJCD", "0.0");
                            if (aRow.get("WGRQ") == null) aRow.put("WGRQ", null);
                            else aRow.put("WGRQ", "'" + aRow.get("WGRQ") + "'");


                            String sql = "insert into centralbase.cb_sucker_rod_specification(well_name,measure_name,measure_id,constructe_date,complete_date,rod_spec,rod_length,rod_deep," +
                                    "rod_class,one_rod_spec,one_rod_count,one_rod_length,two_rod_spec,two_rod_count,two_rod_length,three_rod_spec,three_rod_count,three_rod_length,four_rod_spec," +
                                    "four_rod_count,four_rod_length,rod_short_length,remark,construction_brief) " +
                                    "select '" + aRow.get("JH") + "','" + aRow.get("CSMC") + "','" + aRow.get("CSID") + "','" + aRow.get("SGRQ") + "'," + aRow.get("WGRQ") + ",'" + (aRow.get("GGGG") == null ? "" : aRow.get("GGGG")) + "','" + aRow.get("GGCD") + "','" + aRow.get("GGSD") + "','" + (aRow.get("CYGJB") == null ? "" : aRow.get("CYGJB")) + "','" + (aRow.get("YJCYGGG") == null ? "" : aRow.get("YJCYGGG")) + "','" + aRow.get("YJCYGGS") + "','" + aRow.get("YJCYGCD") + "'" +
                                    " ,'" + (aRow.get("EJCYGGG") == null ? "" : aRow.get("EJCYGGG")) + "','" + aRow.get("EJCYGGS") + "','" + aRow.get("EJCYGCD") + "','" + (aRow.get("SJCYGGG") == null ? "" : aRow.get("SJCYGGG")) + "','" + aRow.get("SJCYGGS") + "','" + aRow.get("SJCYGCD") + "','" + (aRow.get("SJCYGGG4") == null ? "" : aRow.get("SJCYGGG4")) + "','" + aRow.get("SJCYGGS4") + "','" + aRow.get("SJCYGCD4") + "','" + aRow.get("CYGDJCD") + "','" + (aRow.get("BZ") == null ? "" : aRow.get("BZ")) + "','" + (aRow.get("SGJK") == null ? "" : aRow.get("SGJK")) + "'" +
                                    "where NOT EXISTS ( SELECT * FROM centralbase.cb_sucker_rod_specification WHERE well_name = '" + aRow.get("JH") + "' )";
                            aRow.put("SQL", sql);
                        })
                        .doTry()
                        .setBody(simple("${body[SQL]}"))
                        .to("jdbc:centralbase")
                        .doCatch(Exception.class)
                        .log("${body[JH]}" + " routeId:cb_sucker_rod_specification->  centralbase.cb_sucker_rod_specification insert date faild")
                        .end();


                from("timer:mytimer13?period=604800000")
                        .routeId("cb_temp_well_bore_structure")
                        .setBody(simple("delete  from centralbase.cb_temp_well_bore_structure "))
                        .to("jdbc:centralbase")
                        .setBody(simple("SELECT well_id jh FROM centralbase.sys_access_well_control where access_status = '1' and error_id = '1'"))
                        .to("jdbc:centralbase")
                        .split(body()).process(exchange -> {
                            Message in = exchange.getIn();
                            HashMap<String, Object> aRow = in.getBody(HashMap.class);
                            aRow.put("JH", aRow.get("jh").toString());
                            in.setHeader("JH", aRow.get("jh").toString());
                        })
                        .setBody(simple("select jh,cdsd,jxj,fwj,tvd from v_ys_daa03 where jh = '${header.JH}'"))
                        .to("jdbc:oracle_A2")
                        .split(body())
                        .process(exchange -> {
                            Message in = exchange.getIn();
                            HashMap<String, Object> aRow = in.getBody(HashMap.class);
                            if (aRow.get("CDSD") == null) aRow.put("CDSD", "0.0");
                            if (aRow.get("JXJ") == null) aRow.put("JXJ", "0.0");
                            if (aRow.get("FWJ") == null) aRow.put("FWJ", "0.0");
                            if (aRow.get("TVD") == null) aRow.put("TVD", "0.0");
                            String sql = " insert into centralbase.cb_temp_well_bore_structure(well_name,sounding,angle,azimuth,hang_down_deep ) values ( '" + aRow.get("JH") + "'," + aRow.get("CDSD") + "," + aRow.get("JXJ") + "," + aRow.get("FWJ") + "," + aRow.get("TVD") + " )";
                            aRow.put("SQL", sql);
                        })
                        .doTry()
                        .setBody(simple("${body[SQL]}"))
                        .to("jdbc:centralbase")
                        .doCatch(Exception.class)
                        .log(" routeId:cb_temp_well_bore_structure->  centralbase.cb_temp_well_bore_structure insert date faild")
                        .end();


                from("timer:mytimer15?period=604600000")
                        .routeId("cb_temp_oil_jacket_data")
                        .setBody(simple("delete from centralbase.cb_temp_oil_jacket_data "))
                        .to("jdbc:centralbase")
                        .setBody(simple("SELECT well_id jh FROM centralbase.sys_access_well_control where access_status = '1' and error_id = '1'"))
                        .to("jdbc:centralbase")
                        .split(body()).process(exchange -> {
                            Message in = exchange.getIn();
                            HashMap<String, Object> aRow = in.getBody(HashMap.class);
                            aRow.put("JH", aRow.get("jh").toString());
                            in.setHeader("JH", aRow.get("jh").toString());
                        })
                        .setBody(simple("select jh,tgmc,tgwj,xrsd,bh,gj from v_ys_daa04 where jh = '${header.JH}'"))
                        .to("jdbc:oracle_A2")
                        .split(body())
                        .process(exchange -> {
                            Message in = exchange.getIn();
                            HashMap<String, Object> aRow = in.getBody(HashMap.class);
                            if (aRow.get("TGWJ") == null) aRow.put("CDSD", "0.0");
                            if (aRow.get("XRSD") == null) aRow.put("JXJ", "0.0");
                            if (aRow.get("BH") == null) aRow.put("FWJ", "0.0");
                            String sql = "insert into centralbase.cb_temp_oil_jacket_data(well_name,casing_name,casing_diameter,casing_depth,casing_thickness,casing_steel_grade )  values" +
                                    " ( '" + aRow.get("JH") + "','" + aRow.get("TGMC") + "'," + aRow.get("TGWJ") + "," + aRow.get("XRSD") + "," + aRow.get("BH") + " ,'" + aRow.get("BH") + "')";
                            aRow.put("SQL", sql);
                        })
                        .doTry()
                        .setBody(simple("${body[SQL]}"))
                        .to("jdbc:centralbase")
                        .doCatch(Exception.class)
                        .log(" routeId:cb_temp_oil_jacket_data->  centralbase.cb_temp_oil_jacket_data insert date faild")
                        .end();


                from("timer:mytimer16?period=604400000")
                        .routeId("cb_temp_well_saturation_pressure")
                        .setBody(simple("delete from centralbase.cb_temp_well_saturation_pressure "))
                        .to("jdbc:centralbase")
                        .setBody(simple("SELECT well_id jh FROM centralbase.sys_access_well_control where access_status = '1' and error_id = '1'"))
                        .to("jdbc:centralbase")
                        .split(body()).process(exchange -> {
                            Message in = exchange.getIn();
                            HashMap<String, Object> aRow = in.getBody(HashMap.class);
                            aRow.put("JH", aRow.get("jh").toString());
                            in.setHeader("JH", aRow.get("jh").toString());
                        })
                        .setBody(simple("select jh,dydm,ysbhyl from v_ys_dab01 where jh = '${header.JH}'"))
                        .to("jdbc:oracle_A2")
                        .split(body())
                        .process(exchange -> {
                            Message in = exchange.getIn();
                            HashMap<String, Object> aRow = in.getBody(HashMap.class);
                            if (aRow.get("YSBHYL") == null) aRow.put("YSBHYL", "0.0");
                            String sql = "insert into centralbase.cb_temp_well_saturation_pressure(well_name,unit_code,saturat_pressure ) values" +
                                    " ( '" + aRow.get("JH") + "','" + aRow.get("DYDM") + "'," + aRow.get("YSBHYL") + ")";
                            aRow.put("SQL", sql);

                        })
                        .doTry()
                        .setBody(simple("${body[SQL]}"))
                        .to("jdbc:centralbase")
                        .doCatch(Exception.class)
                        .log(" routeId:cb_temp_well_saturation_pressure->  centralbase.cb_temp_well_saturation_pressure insert date faild")
                        .end();

                from("timer:mytimer17?period=604200000")
                        .routeId("cb_temp_density_viscosity")
                        .setBody(simple("delete from centralbase.cb_temp_density_viscosity "))
                        .to("jdbc:centralbase")

                        .setBody(simple("SELECT well_id jh FROM centralbase.sys_access_well_control where access_status = '1' and error_id = '1'"))
                        .to("jdbc:centralbase")
                        .split(body()).process(exchange -> {
                            Message in = exchange.getIn();
                            HashMap<String, Object> aRow = in.getBody(HashMap.class);
                            aRow.put("JH", aRow.get("jh").toString());
                            in.setHeader("JH", aRow.get("jh").toString());
                        })
                        .setBody(simple("select jcd,tqrq,dmyymd,dlzd,ndcdwd,dmyynd, qtxdmd from v_ys_dfc05 where jcd = '${header.JH}'"))
                        .to("jdbc:oracle_A2")
                        .split(body())
                        .process(exchange -> {
                            Message in = exchange.getIn();
                            HashMap<String, Object> aRow = in.getBody(HashMap.class);
                            if (aRow.get("DMYYMD") == null) aRow.put("DMYYMD", "0.0");
                            if (aRow.get("DLZD") == null) aRow.put("DLZD", "0.0");
                            if (aRow.get("NDCDWD") == null) aRow.put("NDCDWD", "0.0");
                            if (aRow.get("DMYYND") == null) aRow.put("DMYYND", "0.0");
                            if (aRow.get("QTXDMD") == null) aRow.put("QTXDMD", "0.0");
                            String sql = "insert into centralbase.cb_temp_density_viscosity(well_name,extract_date,surface_crude_density,dynamic_viscosity,viscosity_measuring_temperature,surface_crude_oil_viscosity, relative_gas_density )  values" +
                                    " ( '" + aRow.get("JCD") + "','" + aRow.get("TQRQ") + "'," + aRow.get("DMYYMD") + "," + aRow.get("DLZD") + "," + aRow.get("NDCDWD") + " ," + aRow.get("DMYYND") + " ," + aRow.get("QTXDMD") + ")";
                            aRow.put("SQL", sql);

                        })
                        .doTry()
                        .setBody(simple("${body[SQL]}"))
                        .to("jdbc:centralbase")
                        .doCatch(Exception.class)
                        .log(" routeId:cb_temp_density_viscosity->  centralbase.cb_temp_density_viscosity insert date faild")
                        .end();

                from("timer:mytimerDelete?period=3600000")
                        .routeId("oracle-Delete")
                        .setBody(simple("select max(prod_date) from centralbase.cb_temp_well_mech_runtime "))
                        .to("jdbc:centralbase")
                        .split(body()).process(exchange -> {
                            Message in = exchange.getIn();
                            in.setHeader("date", getDate() + " 00:00:00");
                        })
                        .doTry()
                        .setBody(simple("delete from centralbase.cb_temp_well_mech_runtime where prod_date > '${header.date}'::TIMESTAMP + '-1 day' and stroke_length = 0 and stroke_frequency = 0 and susp_min_load = 0  "))
                        .to("jdbc:centralbase")
                        .doCatch(Exception.class)
                        .log("${header.date}" + " routeId:oracle-Delete->  centralbase.cb_temp_well_mech_runtime Delete date faild")
                        .end();*/


                //稀稠油信息
                 /*
                 from("timer:mytimer1?period=36000")
                        .routeId("getOrganization")
                        .setBody(simple("select max(id) from public.sys_data_authority_control_unit "))
                        .to("jdbc:public")
                        .process(exchange -> {
                            Message in = exchange.getIn();
                            HashMap<String, Object> aRow = in.getBody(HashMap.class);
                            in.setHeader("maxID", Integer.valueOf(aRow.get("max") == null ? "0": aRow.get("max").toString()) );
                        })
                        .setBody(simple("select org_id,org_name,parent_id from centralbase.cb_pc_organization "))
                        .to("jdbc:centralbase")
                        .split(body()).process(exchange -> {
                            Message in = exchange.getIn();
                            HashMap<String, Object> aRow = in.getBody(HashMap.class);
                            aRow.put("id", Integer.valueOf( in.getHeader("maxId").toString()) +    anInt);
                            anInt++;
                        })
                        .setBody(simple("insert into public.sys_data_authority_control_unit(id,ref_id,ref_name,org_parent_id) " +
                                "select ${body[id]},'${body[org_id]}','${body[org_name]}','${body[parent_id]}' " +
                                "where NOT EXISTS(select * from public.sys_data_authority_control_unit where ref_name = '${body[org_name]}' and org_parent_id = '${body[parent_id]}')"))
                        .doTry()
                        .to("jdbc:public")
                        .doCatch(Exception.class)
                        .log("cb_pc_organization"+"${body[id]}"+"insert data faild")
                        .end();


                    from("timer:mytimer2?period=3600000")
                        .routeId("getWellSource")
                        .setBody(simple("select max(id) from public.sys_data_authority_control_unit "))
                        .to("jdbc:public")
                        .process(exchange -> {
                            Message in = exchange.getIn();
                            HashMap<String, Object> aRow = in.getBody(HashMap.class);
                            in.setHeader("maxID", Integer.valueOf(aRow.get("max").toString()) + 1 );
                        })
                        .setBody(simple("select well_id,org_id,org_name from centralbase.cb_cd_well_source "))
                        .to("jdbc:centralbase")
                        .split(body()).process(exchange -> {
                            Message in = exchange.getIn();
                            HashMap<String, Object> aRow = in.getBody(HashMap.class);
                            int i= 1;
                            aRow.put("id", Integer.valueOf( in.getHeader("maxId").toString()) + i);
                            i++;
                        })
                        .setBody(simple("insert into public.sys_data_authority_control_unit(id,ref_id,ref_name,org_parent_id) " +
                                "select '${body[id]}','${body[org_id]}','${body[org_name]}','${body[parent_id]}' " +
                                "where NOT EXISTS(select * from public.sys_data_authority_control_unit where ref_name = '${body[org_id_pre]}' and org_parent_id = '${body[parent_id]}')"))
                        .doTry()
                        .to("jdbc:public")
                        .doCatch(Exception.class)
                        .log("cb_pc_organization"+"${body[id]}"+"insert data faild")
                        .end();

                from("timer:mytimer3?period=36000")
                        .routeId("updateParentId")
                        .setBody(simple("select  org_parent_id from public.sys_data_authority_control_unit where org_parent_id > 0 "))
                        .to("jdbc:public")
                        .split(body()).process(exchange -> {
                            Message in = exchange.getIn();
                            HashMap<String, Object> aRow = in.getBody(HashMap.class);
                            aRow.put("org_parent_id",aRow.get("org_parent_id"));
                        })
                        .setBody(simple(" update public.sys_data_authority_control_unit set parent_id = (select  id from public.sys_data_authority_control_unit where ref_id  = '${body[org_parent_id]}' ) where  org_parent_id  = '${body[org_parent_id]}' "))
                        .doTry()
                        .to("jdbc:public")
                        .doCatch(Exception.class)
                        .log("updateParentID faild +++++++++++++")
                        .end();









                 from("timer:mytimer9?period=3600000")
                        .routeId("oracle-9")
                        .setBody(simple("select max(prod_date) from centralbase.cb_temp_well_mech_runtime "))
                        .to("jdbc:centralbase")
                        .split(body()).process(exchange -> {
                            Message in = exchange.getIn();
                            in.setHeader("date", getDate());
                })
                        .setBody(simple("select well_common_name,QK,CW,A_RCYOU,A_RCYE,RCYOU,RCYE,HS,LRQ,CZ_YOU,CZ_YE,CMD,SCXJRQ,YCBZ,UP_DATE from V_Cyyc_YcjData where UP_DATE >= to_date('${header.date}','yyyy-MM-dd')"))
                        .to("jdbc:oracle")
                        .split(body()).process(exchange -> {
                            Message in = exchange.getIn();
                            HashMap<String, Object> aRow = in.getBody(HashMap.class);
                            if (aRow.get("LRQ") != null)
                            aRow.put("LRQ",aRow.get("LRQ").toString().substring(0,10));
                            if (aRow.get("SCXJRQ") != null)
                            aRow.put("SCXJRQ",aRow.get("SCXJRQ").toString().substring(0,10));
                            if (aRow.get("UP_DATE") != null)
                            aRow.put("UP_DATE",aRow.get("UP_DATE").toString().substring(0,10));
                })
                        .setBody(simple("insert into centralbase.cb_pc_abnl_model_dgn_thin_heavy(WELL_COMMON_NAME,QK,CW,A_RCYOU,A_RCYE,RCYOU,RCYE,HS,LRQ,CZ_YOU,CZ_YE,CMD,SCXJRQ,YCBZ,UP_DATE) " +
                                        "select '${body[WELL_COMMON_NAME]}','${body[QK]}','${body[CW]}','${body[A_RCYOU]}','${body[A_RCYE]}','${body[RCYOU]}','${body[RCYE]}','${body[HS]}','${body[LRQ]}'," +
                                      " '${body[CZ_YOU]}','${body[CZ_YE]}','${body[CMD]}','${body[SCXJRQ]}','${body[YCBZ]}','${body[UP_DATE]}' " +
                                        "where NOT EXISTS(select * from centralbase.cb_pc_abnl_model_dgn_thin_heavy where well_common_name = '${body[WELL_COMMON_NAME]}' and UP_DATE = '${body[UP_DATE]}')"))
                        .doTry()
                        .to("jdbc:centralbase")
                        .doCatch(Exception.class)
                        .log("${header.date}"+" routeId:oracle-9->  centralbase.cb_pc_pro_wellbore_status_daily update date faild")
                        .end();

               from("timer:mytimer1?period=604800000")
                        .routeId("oracle-1")
                        .setHeader("date", constant(getDate()))
                        .setBody(simple("select org_id,org_name,org_id_pre from centralbase.cb_pc_organization_test where org_level = '3' "))
                        .to("jdbc:centralbase")
                        .split(body())
                        .log("${body[org_id]}")
                        .log("${body[org_name]}")
                        .log("${body[org_id_pre]}")
                        .doTry()
                        .setBody(simple(" update centralbase.cb_pc_organization set org_id_pre = '${body[org_id_pre]}'  where org_id = '${body[org_id]}' "))
                        .to("jdbc:centralbase")
                        .doCatch(Exception.class)
                        .log("${header.date}"+" routeId:oracle-1->  centralbase.cb_pc_organization update date faild")
                        .end();


                from("timer:mytimer1?period=604800000")
                        .routeId("oracle-1")
                        .setHeader("date", constant(getDate()))
                        .setBody(simple("select  well_common_name ,station_id,station_name from centralbase.cb_cd_well_source_test  "))
                        .to("jdbc:centralbase")
                        .split(body())
                        .log("${body[well_common_name]}")
                        .log("${body[station_id]}")
                        .log("${body[station_name]}")
                        .doTry()
                        .setBody(simple(" update centralbase.cb_cd_well_source set station_id = '${body[station_id]}'  ,   station_name = '${body[station_name]}'   where well_common_name = '${body[well_common_name]}' "))
                        .to("jdbc:centralbase")
                        .doCatch(Exception.class)
                        .log("${header.date}"+" routeId:oracle-1->  centralbase.cb_pc_organization update date faild")
                        .end(); */


                //手动导入井信息

//                //修改org_id
//                from("timer:mytimer1?period=604800000")
//                        .routeId("oracle-1")
//                        .setHeader("date", constant(getDate()))
//                        .setBody(simple("select org_id,org_id_pre from centralbase.cb_pc_organization where org_level = '3' "))
//                        .to("jdbc:centralbase")
//                        .split(body())
//                        .doTry()
//                        .setBody(simple("update centralbase.cb_cd_well_source set org_id = '${body[org_id]}' where station_id = '${body[org_id_pre]}'"))
//                        .to("jdbc:centralbase")
//                        .doCatch(Exception.class)
//                        .log("${header.date}"+" routeId:oracle-1->  centralbase.cb_pc_organization update date faild")
//                        .end();

//                        //level3   ------>  用来导入层级
//                        .setBody(simple("select distinct a.org_name_cj zyq,  a.project_name qk , a.station_name zd  from V_CD_WELL_SOURCE_YC a "))
//                        .to("jdbc:oracle")
//                        .split(body()).process(exchange -> {
//                            Message in = exchange.getIn();
//                            HashMap<String, Object> aRow = in.getBody(HashMap.class);
//                            String org_level2 = aRow.get("ZYQ") + "@" + aRow.get("QK")+ "@" + aRow.get("ZD");
//                            String org_level3 = aRow.get("ZYQ") + "@" + aRow.get("QK");
//                            String orgname = aRow.get("ZD").toString();
//                            String zyq = aRow.get("ZYQ").toString();
//                            aRow.put("station_id", org_level2);
//                            aRow.put("org_name",orgname);
//                            aRow.put("zyq",zyq);
//                            aRow.put("lev3",org_level3);
//                        })
//
//                        .log("${body[ZYQ]}")
//                        .doTry()
//                        .setBody(simple("insert into centralbase.cb_pc_organization(org_name,org_level,parent_id,org_id_pre)" +
//                                "values('${body[org_name]}','3',(select org_id from centralbase.cb_pc_organization where org_id_pre = '${body[lev3]}'),'${body[station_id]}') "))
//                        .to("jdbc:centralbase")
//                        .doCatch(Exception.class)
//                        .log("${header.date}"+" routeId:oracle-1->  centralbase.cb_pc_organization insert date faild")
//                        .end();

//                            level2
//                        .setBody(simple("select org_id_pre from centralbase.cb_pc_organization where org_id_pre like '%@%'"))
//                        .to("jdbc:centralbase")
////                        .doCatch(Exception.class)
//                        .split(body())
//                        .log("${body[org_id_pre]}")
//                        .doTry()
//                        .setBody(simple("update centralbase.cb_pc_organization set parent_id = (select org_id from centralbase.cb_pc_organization where org_id_pre = (select split_part(org_id_pre, '@', 1) from centralbase.cb_pc_organization  where org_id_pre = '${body[org_id_pre]}') ) where org_id_pre = '${body[org_id_pre]}' "))
//                        .to("jdbc:centralbase")
//                        .doCatch(Exception.class)
//                        .log("${header.date}"+" routeId:oracle-2->  centralbase.cb_pc_organization insert date faild")
//                        .end();
                //  ,  a.project_name qk , a.station_name zd
//                        .setBody(simple("select distinct a.org_name_cj zyq ,  a.project_name qk from V_CD_WELL_SOURCE_YC a "))
//                        .to("jdbc:oracle")
//                        .split(body()).process(exchange -> {
//                            Message in = exchange.getIn();
//                            HashMap<String, Object> aRow = in.getBody(HashMap.class);
//                            String org_level2 = aRow.get("ZYQ") + "@" + aRow.get("QK");
//                            String org_level3 = aRow.get("ZYQ").toString() ;
//                            String orgname = aRow.get("QK").toString();
//                            String zyq = aRow.get("ZYQ").toString();
//                            aRow.put("station_id", org_level2);
//                            aRow.put("org_name",orgname);
//                            aRow.put("zyq",zyq);
//                            aRow.put("lev3",org_level3);
//                        })
//                        .log("${body[ZYQ]}")
//                        .doTry()
//                        .setBody(simple("insert into centralbase.cb_pc_organization(org_name,org_level,parent_id,org_id_pre)" +
//                                "values('${body[org_name]}','2','0','${body[station_id]}') "))
//                        .to("jdbc:centralbase")
//                        .doCatch(Exception.class)
//                        .log("${header.date}"+" routeId:oracle-1->  centralbase.cb_pc_organization insert date faild")
//                        .end();

//                        .transform()
//                        .body((result) -> {
//                            organization = new TreeSet<>();
//                            orgID = 0;
//                            orgIDs = new HashMap<>();
//                            return result;
//                        })
//                        .step("1")
//                        .split(body()).process(exchange -> {
//                    Message in = exchange.getIn();
//                    HashMap<String, Object> aRow = in.getBody(HashMap.class);
//                    String org_level3 = aRow.get("ZYQ") + "@" + aRow.get("QK") + "@" + aRow.get("ZD");
//                    String org_level2 = aRow.get("ZYQ") + "@" + aRow.get("QK");
//                    String org_level1 = aRow.get("ZYQ").toString();
//                    aRow.put("station_id", org_level3);
//                    //这里是重新生成的orgid，最好先查一下centralbase里已有的
//                    //默认一张新表
//                    if (organization.add(org_level1)) {
//                        orgID++;
//                        orgIDs.put(org_level1, orgID);
//                    }
//                    if (organization.add(org_level2)) {
//                        orgID++;
//                        orgIDs.put(org_level2, orgID);
//                    }
//                    if (organization.add(org_level3)) {
//                        orgID++;
//                        orgIDs.put(org_level3, orgID);
//                    }
//                })
//                    .transform().body((re) -> {
//                    List<Map<String, Object>> rows = new ArrayList<>();
//                    int code = 0;
//                    for (String s : organization) {
//                        code++;// code is same as org_id
//                        String[] orgs = s.split("@");
//                        Map<String, Object> row = new HashMap<>();
//                        row.put("org_id_pre", s);
//                        row.put("org_code", code);
//                        row.put("org_id", "" + code);
//                        switch (orgs.length) {
//                            case 1:
//                                row.put("org_name", orgs[0]);
//                                row.put("org_level", 1);
//                                row.put("org_parent", "0");
//                                break;
//                            case 2:
//                                row.put("org_name", orgs[1]);
//                                row.put("org_level", 2);
//                                row.put("org_parent", orgIDs.get(orgs[0]).toString());
//                                break;
//                            case 3:
//                                row.put("org_name", orgs[2]);
//                                row.put("org_level", 3);
//                                row.put("org_parent", orgIDs.get(orgs[0] + "@" + orgs[1]).toString());
//                                break;
//                        }
//                        rows.add(row);
//                    }
//                    return rows;
//                }).split(body())
//                        .doTry()
//                        .setBody(simple("insert into centralbase.cb_pc_organization(org_id,org_code,org_name,org_level,parent_id,org_id_pre)" +
//                                "values('${body[org_id]}','${body[org_code]}','${body[org_name]}','${body[org_level]}','${body[org_parent]}','${body[org_id_pre]}') "))
//                        .to("jdbc:centralbase")
//                        .doCatch(Exception.class)
//                        .log("${header.date}"+" routeId:oracle-1->  centralbase.cb_pc_organization insert date faild")
//                        .end()


                //导入井的基本信息 导一次就够了
//                from("timer:mytimer1?period=604800000")
//                        .routeId("oracle-1")
//                        .setHeader("date", constant(getDate()))
//                        .setBody(simple("select distinct a.well_common_name jh, a.org_name_cj zyq, a.GROUP_UNIT_NAME cw, a.station_name zd, a.project_name qk from V_CD_WELL_SOURCE_YC a "))
//                        .to("jdbc:oracle")
//                        .transform()
//                        .body((result) -> {
//                            organization = new TreeSet<>();
//                            orgID = 0;
//                            orgIDs = new HashMap<>();
//                            return result;
//                        })
//                        .step("1")
//                        .split(body()).process(exchange -> {
//                    Message in = exchange.getIn();
//                    HashMap<String, Object> aRow = in.getBody(HashMap.class);
//                    String org_level3 = aRow.get("ZYQ") + "@" + aRow.get("QK") + "@" + aRow.get("ZD");
//                    String org_level2 = aRow.get("ZYQ") + "@" + aRow.get("QK");
//                    String org_level1 = aRow.get("ZYQ").toString();
//                    aRow.put("station_id", org_level3);


//                查询井对应dym不为空的数据 --目前是只要对应井能查到dym不为空的,无论是什么时间的,都放进去
//                将查询到的DYM数据更新到cb_pc_pro_wellbore_status_daily中
//                0 0 */1 * * ? 每1个小时执行一次
//                单独执行时间是4m15s 317条数据


//                 没用from("timer:mytimer5?period=3600000")
//                        .routeId("oracle-5")
//                        .setHeader("date", constant(getDate() + " 00:00:00"))
//                        //三个月之内dym不为空的数据
//                        //.setBody(simple("SELECT distinct jh,rq,dym FROM DBA01 WHERE  rq between to_date(TO_CHAR(ADD_MONTHS(SYSDATE,-3),'yyyy-MM-dd'),'yyyy-MM-dd')and to_date(TO_CHAR(SYSDATE,'yyyy-MM-dd'),'yyyy-MM-dd') and dym is not null;"))
//                        .setBody(simple("SELECT  distinct jh,max(rq),dym FROM DBA01 WHERE dym is not null group by jh,dym"))
//                        .to("jdbc:oracle")
//                        .split(body())
//                        .doTry()
//                        .setBody(simple("update centralbase.cb_pc_pro_wellbore_status_daily set start_pump_liq_level = '${body[DYM]}' where well_id = '${body[JH]}' and prod_date::date  = '${header.date}' "))
//                        .to("jdbc:centralbase")
//                        .doCatch(Exception.class)
//                        .log("${header.date}"+" routeId:oracle-5->  centralbase.cb_pc_pro_wellbore_status_daily update date faild")
//                        .end();


//
//                from("timer:mytimer6?period=3600000")
//                        .routeId("oracle-6")
//                        .setHeader("date", constant(getDate() + " 00:00:00"))
//                        //五个月之内bj不为空的数据
//                        .setBody(simple("SELECT distinct jh,bj FROM DBA01 WHERE  rq between to_date(TO_CHAR(ADD_MONTHS(SYSDATE,-5),'yyyy-MM-dd'),'yyyy-MM-dd')and to_date(TO_CHAR(SYSDATE,'yyyy-MM-dd'),'yyyy-MM-dd') and bj is not null"))
//                        .to("jdbc:oracle")
//                        .split(body())
//                        .doTry()
//                        .setBody(simple("update centralbase.cb_temp_well_mech_runtime set pump_diameter = '${body[BJ]}' where well_id = '${body[JH]}' "))
//                        .to("jdbc:centralbase")
//                        .doCatch(Exception.class)
//                        .log("${header.date}"+" routeId:oracle-6->  centralbase.cb_temp_well_mech_runtime update date faild")
//                        .end();
//                //从天安哪里获取的数据
//                //0 0 */1 * * ? 每1个小时执行一次
//                //单独执行一小时的数据30s
//                from("timer:mytimer8?period=3600000")
//                        .routeId("jdbc-gtsj-?")
//                        .setBody(simple("select max(prod_date) from centralbase.cb_temp_well_mech_runtime "))
//                        .to("jdbc:centralbase")
//                        .split(body())
//                        .setHeader("date", simple("${body[max]}"))
//                        .setBody(simple("select distinct well_name,dyna_create_time,check_date,displacement,disp_load,stroke,frequency,susp_max_load,susp_min_load from public.pc_fd_pumpjack_dyna_dia_t where   dyna_create_time > '${header.date}' "))
//                        .to("jdbc:gtsj")
//                        .split(body()).process(exchange -> {
//                    Message in = exchange.getIn();
//                    HashMap<String, Object> aRow = in.getBody(HashMap.class);
//                    String prod_date = aRow.get("dyna_create_time").toString().split("\\+")[0];
//                    aRow.put("dyna_create_time", prod_date);
//                    if (aRow.get("displacement") != null && !aRow.get("displacement").equals("") && aRow.get("disp_load") != null && !aRow.get("disp_load").equals("")) {
//                        String[] displacements = aRow.get("displacement").toString().split(";");//10 四舍五入
//                        //String[] displacements = wy(displacementsOld);
//                        String[] disp_loads = aRow.get("disp_load").toString().split(";");
//                        Double susp_max_load = max(disp_loads);
//                        Double susp_min_load = min(disp_loads);
//                        String sgt = "";
//                        for (int i = 0; i < displacements.length; i++) {
//                            sgt = sgt + displacements[i] + "," + disp_loads[i] + ",";
//                        }
//                        String[] s = sgt.split(",");
//                        String w = "";
//                        for (int i = 0; i < s.length; i++) {
//                            w += new BigDecimal(Math.round(Double.parseDouble(s[i]) * 100)).stripTrailingZeros().toPlainString() + ",";
//                        }
//                        Double[][] doubles = SGTUtil.encodeToDoubleArray(w);
//                      /*  for (int i = 0;i<doubles.length;i++){
//                            doubles[i][0] = doubles[i][0] / 10;
//                        }*/
//                        aRow.put("sgt", SGTUtil.encodeToString(doubles));
//                        aRow.put("susp_max_load",susp_max_load);
//                        aRow.put("susp_min_load",susp_min_load);
//                    }
//                    if (aRow.get("stroke") == null) aRow.put("stroke", "0.0");
//                    if (aRow.get("frequency") == null) aRow.put("frequency", "0.0");
//                    if (aRow.get("susp_max_load") == null) aRow.put("susp_max_load", "0.0");
//                    if (aRow.get("susp_min_load") == null) aRow.put("susp_min_load", "0.0");
//                    if (aRow.get("frequency") != null){
//                        BigDecimal bd=new BigDecimal(aRow.get("frequency").toString());
//                        double frequency=bd.setScale(1,BigDecimal.ROUND_HALF_UP).doubleValue();
//                        aRow.put("frequency",frequency);
//                    }
//                    if (aRow.get("stroke") != null){
//                        double stroke1 = Double.parseDouble(aRow.get("stroke").toString());
//                        BigDecimal bd=new BigDecimal(stroke1);
//                        double stroke=bd.setScale(1,BigDecimal.ROUND_HALF_UP).doubleValue();
//                        aRow.put("stroke",stroke);
//                    }
//                })
//                        .doTry()
//                        .setBody(simple("insert into centralbase.cb_temp_well_mech_runtime(well_id,prod_date,stroke_length,stroke_frequency,susp_max_load,susp_min_load,sgt) " +
//                                "select '${body[well_name]}','${body[dyna_create_time]}','${body[stroke]}','${body[frequency]}','${body[susp_max_load]}','${body[susp_min_load]}','${body[sgt]}' " +
//                                "where NOT EXISTS (SELECT * FROM centralbase.cb_temp_well_mech_runtime WHERE well_id = '${body[well_name]}' and  prod_date = '${body[dyna_create_time]}' )"))
//                        .to("jdbc:centralbase")
//                        .doCatch(Exception.class)
//                        .log("${header.date}"+" routeId:jdbc-gtsj-?->  centralbase.cb_temp_well_mech_runtime insert date faild")
//                        .end();

            }
        };
    }


}